#!/usr/bin/env python
# -*- coding: utf-8 -*-

from gimpfu import *
import sys, os, gettext
import gtk
import subprocess as sub

#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#   The GPL v3 licence is available at: https://www.gnu.org/licenses/gpl-3.0.en.html

# ------------
#| Change Log |
# ------------
# Rel 0.1: Initial release. Inspired by plug-ins export_layers.py https://github.com/khalim19/gimp-plugin-export-layers by khalim19
#                           issue: Batch process?  https://github.com/khalim19/gimp-plugin-export-layers/issues/79
# Rel 0.2: Add option Load/open sources/result.

def sys_file(f_name):
    sys_encoded = sys.getfilesystemencoding()
    if os.name == 'nt': coded = f_name.encode(sys_encoded)
    else: coded = f_name
    return(coded)
	
def python_fu_Batch_Using_Export_Layers(image, layer, indir, file_extension, outdir, load, loadinout):

	pdb.plug_in_export_layers(image, 1, 1, 1, 3, run_mode=RUN_INTERACTIVE)

	for root, dirs, files in os.walk(indir):
		for filename in files:
			filepath = os.path.join(root, filename)
			image = pdb.gimp_file_load(filepath, filename)
			#output_dirpath = os.path.join(r'c:/User/.../...', os.path.splitext(filename)[0])
			output_dirpath = os.path.join(outdir)
			#pdb.plug_in_export_layers(image, file_extension, output_directory, layer_filename_pattern, overwrite_mode)
            # overwrite_mode: "Replace (0)", "Skip (1)", "Rename new file (2)", "Rename existing file (3)"				
			pdb.plug_in_export_layers(image, file_extension, outdir, 1, 3, run_mode=RUN_WITH_LAST_VALS)
			
			if load==1:
				name,ext = os.path.splitext(filename)
				xchange_utf = outdir + os.sep + name + '.' + file_extension
				xchange_sys = sys_file(xchange_utf)
				new_image = pdb.gimp_file_load(xchange_sys, name)
				top_layer = new_image.layers[0]
				top_layer.name = name + '.' + file_extension
				pdb.gimp_display_new(new_image)

			if load==2:
				name,ext = os.path.splitext(filename)
				xchange_utf = outdir + os.sep + name + '.' + file_extension
				xchange_sys = sys_file(xchange_utf)
				new_image = pdb.gimp_file_load(filepath, filename)	
				newlayer = pdb.gimp_file_load_layer(image, xchange_sys)
				pdb.gimp_image_add_layer(image, newlayer, -1)
				bottom_layer = image.layers[-1]
				bottom_layer.name = filename					
				pdb.gimp_display_new(image)
	if loadinout==1:
		new_image = pdb.gimp_file_load(filepath, filename)
		extension = str(file_extension)
		for file in os.listdir(indir):
			if file.lower().split(".")[-1]:
				image_id, layer_ids = pdb.gimp_file_load_layers(new_image, os.path.join(indir, file))
				for id in layer_ids:
					new_layer = gimp.Item.from_id(id)
					pdb.gimp_image_add_layer(new_image, new_layer, 0)
		pdb.gimp_display_new(new_image)
		bottom_layer = new_image.layers[-1]
		pdb.gimp_image_remove_layer(new_image, bottom_layer)
		
	if loadinout==2:
		new_image = pdb.gimp_file_load(filepath, filename)
		extension = str(file_extension)
		for file in os.listdir(outdir):
			if file.lower().split(".")[-1] in (extension):
				image_id, layer_ids = pdb.gimp_file_load_layers(new_image, os.path.join(outdir, file))
				for id in layer_ids:
					new_layer = gimp.Item.from_id(id)
					pdb.gimp_image_add_layer(new_image, new_layer, 0)
		pdb.gimp_display_new(new_image)
		bottom_layer = new_image.layers[-1]
		pdb.gimp_image_remove_layer(new_image, bottom_layer)


		
register (
	"python_fu_Batch_Using_Export_Layers",
	"Batch processing of files using saved settings Export Layers by khalim19 (must be installed).\
	\n\n		Instructions:\n\n1. Select Input directory.\n2. Select New Extension.\n3. Select Output - create or select an EMPTY directory !\n4. Select 'Open as' and click OK.\n\n      In Export Layers (openeds automatically):\n\n5. Select Save in folder = Output !\n6. Select filename [image name] and extension ( = No.2).\n7. Change the order/add/disable/remove Procedures.\n    NOTE: If the procedures envisages adding and keeping\n    a separate layer, the file will open as an image!\n8. Save Setings and close Export Layers.",
	"Changing the file extension (whit preserving the file name) using Export Layers",
	"MareroQ",
	"GPL",
	"2019",
	"Batch Using Export Layers...",
	"*",
	[
	(PF_IMAGE, "image", "", None),
	(PF_DRAWABLE, "drawable", "", None),
	(PF_DIRNAME, "indir", "Input directory (source): ", ""),
	(PF_STRING, "file_extension", "New Extension:", "png"),
	(PF_DIRNAME, "outdir", "Output directory (result): ", ""),	
	(PF_OPTION, "load", "Open as New Images: ", 0, ["DON'T USE", "Separately  = only result", "In pairs = result + source"]),
	(PF_OPTION, "load", "Open as Layers: ", 0, ["DON'T USE", "All Input files (source)", "All Output files (result)"]),	
	],
	[],
	python_fu_Batch_Using_Export_Layers, menu = "<Image>/File/Open/"
	)

main()
